import React from "react";
import { ReactNode } from "react";
import { Graph } from "../structures/graph/graph";
import "./nodetypeseditor.css";
import { NodeTypeEntry } from "./nodetypeentry";
import { NodeType } from "../structures/graph/nodetype";

type propTypes = {
    graph: Graph;
    onChange: { (): void };
};

export class NodeTypesEditor extends React.Component<propTypes> {
    constructor(props: propTypes) {
        super(props);
        this.addType = this.addType.bind(this);
    }

    private addType() {
        const type = new NodeType(this.props.graph);
        type.add();
    }

    render(): ReactNode {
        if (this.props.graph === undefined) {
            return "No graph selected.";
        }

        return (
            <div id="node-types-editor">
                <ul>
                    {this.props.graph.types.map((type) => (
                        <NodeTypeEntry
                            onChange={this.props.onChange}
                            key={type.id}
                            type={type}
                            graph={this.props.graph}
                        />
                    ))}
                </ul>
                <button onClick={this.addType}>Add type</button>
            </div>
        );
    }
}
