import React from "react";
import { ReactNode } from "react";
import "./spacemanager.css";

type propTypes = unknown;
type stateTypes = {
    hidden: boolean;
    deleteConfirmationHidden: boolean;
    newName: string;
};

export class SpaceManager extends React.Component<propTypes, stateTypes> {
    constructor(props: propTypes) {
        super(props);
        this.deleteSpace = this.deleteSpace.bind(this);

        this.state = {
            hidden: true,
            deleteConfirmationHidden: true,
            newName: "New space",
        };
    }

    private deleteSpace() {
        this.setState({
            deleteConfirmationHidden: true,
        });
    }

    render(): ReactNode {
        return (
            <div id="space-manager">
                <button
                    className="warning"
                    onClick={() =>
                        this.setState({
                            hidden: !this.state.hidden,
                            deleteConfirmationHidden: true,
                        })
                    }
                >
                    Manage Space
                </button>
                {this.state.hidden ? (
                    ""
                ) : (
                    <div id="pop-up">
                        <input
                            className="space-name"
                            type={"text"}
                            value={this.state.newName}
                            onChange={(event) =>
                                this.setState({ newName: event.target.value })
                            }
                        />
                        <ul>
                            <li>
                                <button>
                                    Rename to {'"' + this.state.newName + '"'}
                                </button>
                            </li>
                            <li>
                                <button>
                                    Duplicate as{" "}
                                    {'"' + this.state.newName + '"'}
                                </button>
                            </li>
                            <li>
                                <button>
                                    Create empty space{" "}
                                    {'"' + this.state.newName + '"'}
                                </button>
                            </li>
                        </ul>
                        <hr />
                        <ul>
                            <li>
                                <button
                                    onClick={() =>
                                        this.setState({
                                            deleteConfirmationHidden:
                                                !this.state
                                                    .deleteConfirmationHidden,
                                        })
                                    }
                                >
                                    Delete Space?
                                </button>
                            </li>
                            {this.state.deleteConfirmationHidden ? (
                                ""
                            ) : (
                                <li>
                                    <button
                                        className="warning"
                                        onClick={this.deleteSpace}
                                    >
                                        Delete the space and all its data
                                    </button>
                                </li>
                            )}
                        </ul>
                    </div>
                )}
            </div>
        );
    }
}
